!---------------------------------------------------------------------
!     Copyright (C) GFD Dennou Club, 2005. All rights reserved.
!---------------------------------------------------------------------
!= Module LBFlux
!
!   * Developer: SUGIYAMA Ko-ichiro
!   * Version: $Id: blflux.f90,v 1.1.1.1 2006/04/25 03:43:58 deepconv Exp $
!   * Tag Name: $Name: arare4-20060426 $
!   * Change History: 
!
!== Overview
!
!ǤΥեåη׻⥸塼
!
!== Error Handling
!
!== Bugs
!
!== Note
!
!  * 1.5 Υ㡼Ѥ
!  * 꼰 CReSS Υޥ˥奢򻲾Ȥ
!
!== Future Plans
!
!

module LBFlux
  !
  !ǤΥեåη׻⥸塼
  !
  
  !⥸塼ɤ߹
  use gridset,  only: DimXMin,         & !x β
    &                 DimXMax,         & !x ξ
    &                 DimZMin,         & !z β
    &                 DimZMax,         & !z ξ
    &                 RegZMin,         & !z ʪΰβ
    &                 DelZ               !z γʻֳ
  use basicset, only: xz_PotTempBasicZ, &!̤δܾ
    &                 xz_ExnerBasicZ     !ʡؿδܾ
  use average,  only: xz_avr_pz

  !ۤηػ
  implicit none

  !°λ
  private

  !ؿ public 
  public xz_HFluxSfc
  public pz_MFluxSfc

  !ѿ
  real(8)  :: Bulk = 1.0d-2        !Ǯư̥եåΥХ륯
  real(8)  :: TempFlux = 370.0d0   !ɽ̤Υեå(ٸ)

  !ͤ¸
  save Bulk, TempFlux

contains

!!!------------------------------------------------------------------------!!!
  function xz_HFluxSfc( pz_VelX, xz_PotTemp, xz_Exner )
    !
    !ɽǮեå׻. 
    !
    
    !ۤηػ
    implicit none
    
    !ѿ
    real(8), intent(in)   :: pz_VelX(DimXMin:DimXMax,DimZMin:DimZMax)
                                           !ʿ®٤ξʬ
    real(8), intent(in)   :: xz_PotTemp(DimXMin:DimXMax,DimZMin:DimZMax)
                                           !̤ξʬ    
    real(8), intent(in)   :: xz_Exner(DimXMin:DimXMax,DimZMin:DimZMax)
                                           !ʡؿξʬ
    real(8)               :: xz_HFluxSfc(DimXMin:DimXMax,DimZMin:DimZMax)
                                           !ɽǮեå
    real(8)               :: xz_TempAll(DimXMin:DimXMax,DimZMin:DimZMax)
                                           ! (ܾ + ʬ)

    !ǥǲؤǤβ٤
    xz_TempAll =   ( xz_PotTemp + xz_PotTempBasicZ ) &
      &          * ( xz_Exner   + xz_ExnerBasicZ   )
    
    !ɽǮեå׻
    xz_HFluxSfc =                                                            &
      & Bulk * xz_avr_pz( abs( pz_VelX ) ) * ( TempFlux - xz_TempAll ) / DelZ

    !RegZMin + 1 ǤΤͤĤ褦ˤ
    xz_HFluxSfc(:,DimZMin:RegZMin)   = 0.0d0
    xz_HFluxSfc(:,RegZMin+2:DimZMax) = 0.0d0
    
  end function xz_HFluxSfc
  


!!!------------------------------------------------------------------------!!!
  function pz_MFluxSfc( pz_VelX )    
    !
    !ɽ̱ư̥եå׻
    !
    
    !ۤηػ
    implicit none

    !ѿ
    real(8), intent(in)   :: pz_VelX(DimXMin:DimXMax,DimZMin:DimZMax)
                                           !ʿ®٤ξʬ
    real(8)               :: pz_MFluxSfc(DimXMin:DimXMax,DimZMin:DimZMax)
                                           !ɽ̱ư̥եå

    !ɽ̱ư̥եå׻
    pz_MFluxSfc = - Bulk * abs( pz_VelX ) * pz_VelX / DelZ
    
    !RegZMin + 1 ǤΤͤĤ褦ˤ
    pz_MFluxSfc(:,DimZMin:RegZMin)   = 0.0d0
    pz_MFluxSfc(:,RegZMin+2:DimZMax) = 0.0d0

  end function pz_MFluxSfc

  
end module LBFlux
