!---------------------------------------------------------------------
!     Copyright (C) GFD Dennou Club, 2004, 2005, 2006. All rights reserved.
!---------------------------------------------------------------------
!= Module FileSet
!
!   * Developer: SUGIYAMA Ko-ichiro 
!   * Version: $Id: fileset.f90,v 1.1.1.1 2006/04/25 03:43:58 deepconv Exp $ 
!   * Tag Name: $Name: arare4-20060426 $
!   * Change History: 
!
!== Overview 
!
!Ϳ줿 NAMELIST ե뤫, ե̾ɽξ
!ݴɤ뤿ѿ⥸塼
!
!== Error Handling
!
!== Known Bugs
!
!== Note
!
!== Future Plans
!

module fileset
  !
  !Ϳ줿 NAMELIST ե뤫, I/O ե̾, 
  !ݴɤ뤿ѿ⥸塼
  !

  !ۤηػ
  implicit none

  !save °
  save

  !ѿ
  character(80) :: InitFile          !ͥե
  character(80) :: HistoryFile       !ҥȥ꡼ե
  character(80) :: ReStartFile       !ꥹȥե
  character(80) :: RandomFile        !ե
  character(80) :: ExpTitle          !ǡɽ
  character(80) :: ExpSrc            !ǡ
  character(80) :: ExpInst           !ǽѹԡȿ

contains

  subroutine fileset_init(cfgfile)
    !
    !NAMELIST ե̾դ륿, ϥե̾. 
    !

    !⥸塼ɤ߹
    use dc_message,    only: MessageNotify

    !ۤηػ
    implicit none

    !ѿ
    character(*), intent(in) :: cfgfile

    !NAMELIST 
    NAMELIST /fileset/                                  &
      & InitFile, HistoryFile, ReStartFile, RandomFile, &
      & ExpTitle, ExpSrc,      ExpInst

    open (10, FILE=cfgfile)
    read(10, NML=fileset)
    close(10)

    !ǧ
    call MessageNotify("Message", "fileset_init, InitFile   ", InitFile)
    call MessageNotify("Message", "fileset_init, HistoryFile", HistoryFile)
    call MessageNotify("Message", "fileset_init, ReStartFile", ReStartFile)
    call MessageNotify("Message", "fileset_init, RandomFile ", RandomFile)
    call MessageNotify("Message", "fileset_init, ExpTitle   ", ExpTitle)
    call MessageNotify("Message", "fileset_init, ExpSrc     ", ExpSrc)
    call MessageNotify("Message", "fileset_init, ExpInst    ", ExpInst)
    
  end subroutine fileset_init
end module fileset
